`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:24:52 05/19/2007 
// Design Name: 
// Module Name:    kiserlet_top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module kiserlet_top(CLK, OUT, REC, SEND, BUTTON, DIR1, EN1);
    input CLK;
    output [7:0] OUT;
    input REC;
    output SEND;
	 input BUTTON;
	 output DIR1;
	 output EN1;

	wire [7:0]bus1;
	wire orajel;			//divided clock
	wire rcvd;				//data has been received
	reg trmt;				//start transmit
	wire tr_iproc;			//transmit in process
	reg [7:0]data_rcvd;	//data buffer
	reg [15:0]postsc;		//post scaler

	prescaler p1(CLK,orajel);
	//assign orajel=CLK;
	
	receiver r1(REC,bus1,orajel,rcvd);
	transmitter t1(orajel,data_rcvd,trmt,SEND,tr_inproc);
	
	always@(posedge orajel)
		begin
		postsc<=postsc+1;
		if(rcvd==1)data_rcvd<=bus1+1;
		if(!BUTTON&&!tr_inproc&&(postsc==16'h0000))trmt=1;
		else trmt=0;
		end
		
	assign OUT=data_rcvd;
	
	assign DIR1=1;
	assign EN1=0;

endmodule
